NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Positioning::ConstraintReference Class Reference

ConstraintReference for use in positioning objects in NX. More...

Inheritance diagram for NXOpen::Positioning::ConstraintReference:
NXOpen::NXObject NXOpen::TaggedObject NXOpen::INXObject

Public Types

enum  ConstraintOrder { ConstraintOrderUnknown, ConstraintOrderInside, ConstraintOrderOutside }
 Specifies the order of the constraint reference used in a NXOpen::Positioning::Constraint . More...
 
enum  GeometryType {
  GeometryTypeUnknown = -1, GeometryTypePoint, GeometryTypeLine, GeometryTypeCircle,
  GeometryTypePlane, GeometryTypeCylinder, GeometryTypeSphere, GeometryTypeSweepSurface,
  GeometryTypeParametricSurface, GeometryTypeParametricCurve, GeometryTypeSplineCurve, GeometryTypeTorus,
  GeometryTypeCone, GeometryTypeEllipse, GeometryTypeSplineSurface, GeometryTypeCoordinateSystem = 1001
}
 Specifies the type of the geometry used in a NXOpen::Positioning::ConstraintReference . More...
 
enum  HalfSpace { HalfSpaceInfer, HalfSpacePositive, HalfSpaceNegative }
 Specifies the half space value of one geometry used in a distance constraint. More...
 
- Public Types inherited from NXOpen::NXObject
enum  AttributeType {
  AttributeTypeInvalid, AttributeTypeNull, AttributeTypeBoolean, AttributeTypeInteger,
  AttributeTypeReal, AttributeTypeString, AttributeTypeTime, AttributeTypeReference,
  AttributeTypeAny = 100
}
 Specifies attribute type. More...
 
enum  DateAndTimeFormat { DateAndTimeFormatNumeric, DateAndTimeFormatTextual }
 Specifies the format of the date and time attribute. More...
 

Public Member Functions

NXOpen::Positioning::ConstraintReference::HalfSpace ConstraintReferenceHalfSpace ()
 Returns the half_space value for the constraint reference. More...
 
bool GeometryDirectionReversed ()
 Returns whether the direction is reversed with respect to the direction of the geometry. More...
 
NXOpen::NXObjectGetGeometry ()
 Returns the geometry of the constraint reference. More...
 
bool GetHasPerpendicularVector ()
 Get the flag indicating whether the constraint reference is one that maintains a direction perpendicular to the primary geometry. More...
 
NXOpen::NXObjectGetMovableObject ()
 Returns the movable object of the constraint reference. More...
 
NXOpen::NXObjectGetPrototypeGeometry ()
 Returns the prototype geometry of the constraint reference. More...
 
NXOpen::Vector3d GetPrototypePerpendicularVector ()
 Get the value of the perpendicular vector, which will be (0,0,0) for most constraints apart from NXOpen::Positioning::Constraint::TypeAlignLock . More...
 
bool GetUsePortRotate ()
 Get the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system. More...
 
bool GetUsesGeometryAxis ()
 Returns if the constraint reference should use the axis of the geometry (for example a cylindrical face) rather than the surface. More...
 
NXOpen::Point3d HelpPoint ()
 Returns the help point of the constraint reference. More...
 
NXOpen::Positioning::ConstraintReference::ConstraintOrder Order ()
 Returns the order of the constraint reference within its constraint. More...
 
void SetConstraintReferenceHalfSpace (NXOpen::Positioning::ConstraintReference::HalfSpace halfSpace)
 Sets the half_space value for the constraint reference. More...
 
void SetFixHint (bool set)
 Set a hint to the solver to fix the movable object associated with this constraint reference. More...
 
void SetFixHintForUpdate (bool set)
 Set a hint to the solver to fix the movable object associated with this constraint reference. More...
 
void SetGeometryDirectionReversed (bool geometryDirectionReversed)
 Sets whether the direction is reversed with respect to the direction of the geometry. More...
 
void SetHelpPoint (const NXOpen::Point3d &helpPoint)
 Sets the help point of the constraint reference. More...
 
void SetPrototypePerpendicularVector (const NXOpen::Vector3d &perpendicularVector)
 Set the value of the perpendicular vector. More...
 
void SetUsePortRotateFlag (bool useRotate)
 Sets the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system. More...
 
NXOpen::Positioning::ConstraintReference::GeometryType SolverGeometryType ()
 Returns the geometry type of the constraint reference used during a solve. More...
 
bool UsePortRotateFlag ()
 Returns the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system. More...
 
- Public Member Functions inherited from NXOpen::NXObject
NXOpen::AttributeIteratorCreateAttributeIterator ()
 Create an attribute iterator. More...
 
void DeleteAllAttributesByType (NXOpen::NXObject::AttributeType type)
 Deletes all attributes of a specific type. More...
 
void DeleteAllAttributesByType (NXOpen::NXObject::AttributeType type, NXOpen::Update::Option option)
 Deletes all attributes of a specific type with the option to update or not. More...
 
void DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const NXString &title)
 Deletes an attribute by type and title. More...
 
void DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const char *title)
 Deletes an attribute by type and title. More...
 
void DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const NXString &title, NXOpen::Update::Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
void DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const char *title, NXOpen::Update::Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
void DeleteUserAttribute (NXOpen::NXObject::AttributeType type, const NXString &title, bool deleteEntireArray, NXOpen::Update::Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
void DeleteUserAttribute (NXOpen::NXObject::AttributeType type, const char *title, bool deleteEntireArray, NXOpen::Update::Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
void DeleteUserAttributes (NXOpen::AttributeIterator *iterator, NXOpen::Update::Option option)
 Deletes the attributes on the object, if any, that satisfy the given iterator
Created in NX8.0.0. More...
 
void DeleteUserAttributes (NXOpen::NXObject::AttributeType type, NXOpen::Update::Option option)
 Deletes the attributes encountered with the given Type with option to update or not. More...
 
virtual NXOpen::INXObjectFindObject (const NXString &journalIdentifier)
 Finds the NXOpen::NXObject with the given identifier as recorded in a journal. More...
 
virtual NXOpen::INXObjectFindObject (const char *journalIdentifier)
 Finds the NXOpen::NXObject with the given identifier as recorded in a journal. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetAttributeTitlesByType (NXOpen::NXObject::AttributeType type)
 Gets all the attribute titles of a specific type. More...
 
bool GetBooleanUserAttribute (const NXString &title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
bool GetBooleanUserAttribute (const char *title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
NXOpen::NXObject::ComputationalTime GetComputationalTimeUserAttribute (const NXString &title, int index)
 Gets a time attribute by Title and array Index. More...
 
NXOpen::NXObject::ComputationalTime GetComputationalTimeUserAttribute (const char *title, int index)
 Gets a time attribute by Title and array Index. More...
 
int GetIntegerAttribute (const NXString &title)
 Gets an integer attribute by title. More...
 
int GetIntegerAttribute (const char *title)
 Gets an integer attribute by title. More...
 
int GetIntegerUserAttribute (const NXString &title, int index)
 Gets an integer attribute by Title and array Index. More...
 
int GetIntegerUserAttribute (const char *title, int index)
 Gets an integer attribute by Title and array Index. More...
 
bool GetNextUserAttribute (NXOpen::AttributeIterator *iterator, NXOpen::NXObject::AttributeInformation *info)
 Gets the next attribute encountered on the object, if any, that satisfies the given iterator. More...
 
NXString GetPdmReferenceAttributeValue (const NXString &attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
NXString GetPdmReferenceAttributeValue (const char *attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
double GetRealAttribute (const NXString &title)
 Gets a real attribute by title. More...
 
double GetRealAttribute (const char *title)
 Gets a real attribute by title. More...
 
double GetRealUserAttribute (const NXString &title, int index)
 Gets a real attribute by Title and array Index. More...
 
double GetRealUserAttribute (const char *title, int index)
 Gets a real attribute by Title and array Index. More...
 
NXString GetReferenceAttribute (const NXString &title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
NXString GetReferenceAttribute (const char *title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
NXString GetStringAttribute (const NXString &title)
 Gets a string attribute value by title. More...
 
NXString GetStringAttribute (const char *title)
 Gets a string attribute value by title. More...
 
NXString GetStringUserAttribute (const NXString &title, int index)
 Gets a string attribute by Title and array Index. More...
 
NXString GetStringUserAttribute (const char *title, int index)
 Gets a string attribute by Title and array Index. More...
 
NXString GetTimeAttribute (NXOpen::NXObject::DateAndTimeFormat format, const NXString &title)
 Gets a time attribute by title. More...
 
NXString GetTimeAttribute (NXOpen::NXObject::DateAndTimeFormat format, const char *title)
 Gets a time attribute by title. More...
 
NXString GetTimeUserAttribute (const NXString &title, int index)
 Gets a time attribute by Title and array Index. More...
 
NXString GetTimeUserAttribute (const char *title, int index)
 Gets a time attribute by Title and array Index. More...
 
NXOpen::NXObject::AttributeInformation GetUserAttribute (const NXString &title, NXOpen::NXObject::AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
NXOpen::NXObject::AttributeInformation GetUserAttribute (const char *title, NXOpen::NXObject::AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttribute (const NXString &title, bool includeUnset, bool addStringValues, NXOpen::NXObject::AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttribute (const char *title, bool includeUnset, bool addStringValues, NXOpen::NXObject::AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
NXString GetUserAttributeAsString (const NXString &title, NXOpen::NXObject::AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
NXString GetUserAttributeAsString (const char *title, NXOpen::NXObject::AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
int GetUserAttributeCount (NXOpen::AttributeIterator *iterator)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
int GetUserAttributeCount (NXOpen::AttributeIterator *iterator, bool countArrayAsOneAttribute)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
int GetUserAttributeCount (NXOpen::NXObject::AttributeType type)
 Gets the count of set attributes on the object, if any, of the given type. More...
 
int GetUserAttributeCount (NXOpen::NXObject::AttributeType type, bool includeUnset, bool countArrayAsOneAttribute)
 Gets the count of attributes on the object, if any, of the given type. More...
 
bool GetUserAttributeLock (const NXString &title, NXOpen::NXObject::AttributeType type)
 Determine the lock of the given attribute. More...
 
bool GetUserAttributeLock (const char *title, NXOpen::NXObject::AttributeType type)
 Determine the lock of the given attribute. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttributes (NXOpen::AttributeIterator *iterator)
 Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttributes ()
 Gets all the attributes that have been set on the given object. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttributes (bool includeUnset)
 Gets all the attributes of the given object. More...
 
std::vector
< NXOpen::NXObject::AttributeInformation
GetUserAttributes (bool includeUnset, bool addStringValues)
 Gets all the attributes of the given object. More...
 
std::vector< NXStringGetUserAttributesAsStrings ()
 Gets all the attributes that have been set on the given object. More...
 
int GetUserAttributeSize (const NXString &title, NXOpen::NXObject::AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
int GetUserAttributeSize (const char *title, NXOpen::NXObject::AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
std::vector< NXOpen::NXObject * > GetUserAttributeSourceObjects ()
 Returns an array of objects from which this object presents attributes. More...
 
bool HasUserAttribute (NXOpen::AttributeIterator *iterator)
 Determines if an attribute exists on the object, that satisfies the given iterator. More...
 
bool HasUserAttribute (const NXString &title, NXOpen::NXObject::AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
bool HasUserAttribute (const char *title, NXOpen::NXObject::AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
virtual bool IsOccurrence ()
 Returns whether this object is an occurrence or not. More...
 
virtual NXString JournalIdentifier ()
 Returns the identifier that would be recorded in a journal for this object. More...
 
virtual NXString Name ()
 Returns the custom name of the object. More...
 
virtual
NXOpen::Assemblies::Component
OwningComponent ()
 Returns the owning component, if this object is an occurrence. More...
 
virtual NXOpen::BasePartOwningPart ()
 Returns the owning part of this object
Created in NX3.0.0. More...
 
virtual void Print ()
 Prints a representation of this object to the system log file. More...
 
virtual NXOpen::INXObjectPrototype ()
 Returns the prototype of this object if it is an occurrence. More...
 
void SetAttribute (const NXString &title, int value)
 Creates or modifies an integer attribute. More...
 
void SetAttribute (const char *title, int value)
 Creates or modifies an integer attribute. More...
 
void SetAttribute (const NXString &title, int value, NXOpen::Update::Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
void SetAttribute (const char *title, int value, NXOpen::Update::Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
void SetAttribute (const NXString &title, double value)
 Creates or modifies a real attribute. More...
 
void SetAttribute (const char *title, double value)
 Creates or modifies a real attribute. More...
 
void SetAttribute (const NXString &title, double value, NXOpen::Update::Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
void SetAttribute (const char *title, double value, NXOpen::Update::Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
void SetAttribute (const NXString &title, const NXString &value)
 Creates or modifies a string attribute. More...
 
void SetAttribute (const char *title, const char *value)
 Creates or modifies a string attribute. More...
 
void SetAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
void SetAttribute (const char *title, const char *value, NXOpen::Update::Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
void SetAttribute (const NXString &title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
void SetAttribute (const char *title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
void SetAttribute (const NXString &title, NXOpen::Update::Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
void SetAttribute (const char *title, NXOpen::Update::Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
void SetBooleanUserAttribute (const NXString &title, int index, bool value, NXOpen::Update::Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
void SetBooleanUserAttribute (const char *title, int index, bool value, NXOpen::Update::Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
virtual void SetName (const NXString &name)
 Sets the custom name of the object. More...
 
virtual void SetName (const char *name)
 Sets the custom name of the object. More...
 
void SetPdmReferenceAttribute (const NXString &attributeTitle, const NXString &attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
void SetPdmReferenceAttribute (const char *attributeTitle, const char *attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
void SetReferenceAttribute (const NXString &title, const NXString &value)
 Creates or modifies a string attribute which uses a reference string. More...
 
void SetReferenceAttribute (const char *title, const char *value)
 Creates or modifies a string attribute which uses a reference string. More...
 
void SetReferenceAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
void SetReferenceAttribute (const char *title, const char *value, NXOpen::Update::Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
void SetTimeAttribute (const NXString &title, const NXString &value)
 Creates or modifies a time attribute. More...
 
void SetTimeAttribute (const char *title, const char *value)
 Creates or modifies a time attribute. More...
 
void SetTimeAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetTimeAttribute (const char *title, const char *value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetTimeUserAttribute (const NXString &title, int index, const NXString &value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetTimeUserAttribute (const char *title, int index, const char *value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetTimeUserAttribute (const NXString &title, int index, const NXOpen::NXObject::ComputationalTime &value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetTimeUserAttribute (const char *title, int index, const NXOpen::NXObject::ComputationalTime &value, NXOpen::Update::Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
void SetUserAttribute (const NXOpen::NXObject::AttributeInformation &info, NXOpen::Update::Option option)
 Creates or modifies an attribute with the option to update or not. More...
 
void SetUserAttribute (const NXString &title, int index, int value, NXOpen::Update::Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
void SetUserAttribute (const char *title, int index, int value, NXOpen::Update::Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
void SetUserAttribute (const NXString &title, int index, double value, NXOpen::Update::Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
void SetUserAttribute (const char *title, int index, double value, NXOpen::Update::Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
void SetUserAttribute (const NXString &title, int index, const NXString &value, NXOpen::Update::Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
void SetUserAttribute (const char *title, int index, const char *value, NXOpen::Update::Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
void SetUserAttribute (const NXString &title, int index, NXOpen::Update::Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
void SetUserAttribute (const char *title, int index, NXOpen::Update::Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
void SetUserAttributeLock (const NXString &title, NXOpen::NXObject::AttributeType type, bool lock)
 Lock or unlock the given attribute. More...
 
void SetUserAttributeLock (const char *title, NXOpen::NXObject::AttributeType type, bool lock)
 Lock or unlock the given attribute. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

ConstraintReference for use in positioning objects in NX.

A ConstraintReference is used by a Constraint to determine the movable object to be positioned by the constraint and the geometry used to define the constraint.
To create an instance of this class, use NXOpen::Positioning::Constraint::CreateConstraintReference .

Created in NX4.0.0.

Member Enumeration Documentation

Specifies the order of the constraint reference used in a NXOpen::Positioning::Constraint .

Typically the order is set during creation, where the first constraint reference added is "outside" and the second "outside". For Bond constraints, the order is set to be "unknown" at creation.

Enumerator
ConstraintOrderUnknown 

No order specified.

ConstraintOrderInside 

Inside.

ConstraintOrderOutside 

Outside.

Specifies the type of the geometry used in a NXOpen::Positioning::ConstraintReference .

The type reflects that used in a NXOpen::Positioning::Constraint while it is being solved and may be different from that inferred directly from NXOpen::Positioning::ConstraintReference::GetGeometry . For example we may use NXOpen::Positioning::ConstraintReference::GeometryTypeLine as an axis when given a cylindrical face as the geometry.

Enumerator
GeometryTypeUnknown 

No geometry suitable for solving.

GeometryTypePoint 

Point.

GeometryTypeLine 

Straight line.

GeometryTypeCircle 

Circle.

GeometryTypePlane 

Plane.

GeometryTypeCylinder 

Cylinder.

GeometryTypeSphere 

Sphere.

GeometryTypeSweepSurface 

Swept surface.

GeometryTypeParametricSurface 

Parametric surface.

GeometryTypeParametricCurve 

Parametric curve.

GeometryTypeSplineCurve 

Spline curve.

GeometryTypeTorus 

Torus.

GeometryTypeCone 

Cone.

GeometryTypeEllipse 

Ellipse.

GeometryTypeSplineSurface 

Spline surface.

GeometryTypeCoordinateSystem 

Coordinate system.

Specifies the half space value of one geometry used in a distance constraint.

This is only used for surface geometries, and it determines which side of the surface the distance constraint is measured from.

Enumerator
HalfSpaceInfer 

Allow the solver to decide the half space value, or the geometry is not a surface.

HalfSpacePositive 

Measure to the positive side of the surface.

HalfSpaceNegative 

Measure to the negative side of the surface.

Member Function Documentation

NXOpen::Positioning::ConstraintReference::HalfSpace NXOpen::Positioning::ConstraintReference::ConstraintReferenceHalfSpace ( )

Returns the half_space value for the constraint reference.

This is only used for distance constraints.


Created in NX5.0.1.

License requirements : assemblies ("ASSEMBLIES MODULE")

bool NXOpen::Positioning::ConstraintReference::GeometryDirectionReversed ( )

Returns whether the direction is reversed with respect to the direction of the geometry.

This property is only used if the underlying geometry can have an associated direction.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

NXOpen::NXObject* NXOpen::Positioning::ConstraintReference::GetGeometry ( )

Returns the geometry of the constraint reference.

This is the geometry used in any NXOpen::Positioning::Constraint using this constraint reference.

Returns
The geometry referenced by the constraint
Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
bool NXOpen::Positioning::ConstraintReference::GetHasPerpendicularVector ( )

Get the flag indicating whether the constraint reference is one that maintains a direction perpendicular to the primary geometry.

This is only applicable to NXOpen::Positioning::Constraint::Type NXOpen::Positioning::Constraint::TypeAlignLock .

Returns
Whether the constraint has a perpendicular vector
Created in NX9.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
NXOpen::NXObject* NXOpen::Positioning::ConstraintReference::GetMovableObject ( )

Returns the movable object of the constraint reference.

The movable object determines the object to be positioned by any NXOpen::Positioning::Constraint using this constraint reference.

Returns
The object positioned by the constraint
Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
NXOpen::NXObject* NXOpen::Positioning::ConstraintReference::GetPrototypeGeometry ( )

Returns the prototype geometry of the constraint reference.

This is never an occurrence.

Returns
The prototype geometry referenced by the constraint
Created in NX9.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
NXOpen::Vector3d NXOpen::Positioning::ConstraintReference::GetPrototypePerpendicularVector ( )

Get the value of the perpendicular vector, which will be (0,0,0) for most constraints apart from NXOpen::Positioning::Constraint::TypeAlignLock .

Returns
The value of the perpendicular vector
Created in NX9.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
bool NXOpen::Positioning::ConstraintReference::GetUsePortRotate ( )

Get the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system.

Only effective when the referenced geometry is a NXOpen::Routing::Port object.

Returns

Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
bool NXOpen::Positioning::ConstraintReference::GetUsesGeometryAxis ( )

Returns if the constraint reference should use the axis of the geometry (for example a cylindrical face) rather than the surface.

Returns
If this reference is using the axis of the geometry
Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")
NXOpen::Point3d NXOpen::Positioning::ConstraintReference::HelpPoint ( )

Returns the help point of the constraint reference.


Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

NXOpen::Positioning::ConstraintReference::ConstraintOrder NXOpen::Positioning::ConstraintReference::Order ( )

Returns the order of the constraint reference within its constraint.

Note that this order is not associated with the geometry or with the alignment of the constraint. It is based on the idea that the constraint has a direction from "outside" to "inside". It does not affect the result of a solve.


Created in NX5.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

void NXOpen::Positioning::ConstraintReference::SetConstraintReferenceHalfSpace ( NXOpen::Positioning::ConstraintReference::HalfSpace  halfSpace)

Sets the half_space value for the constraint reference.

This is only used for distance constraints.


Created in NX5.0.1.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
halfSpaceHalf space for constraint reference
void NXOpen::Positioning::ConstraintReference::SetFixHint ( bool  set)

Set a hint to the solver to fix the movable object associated with this constraint reference.

The hint is unset when "set" is false.

The hint can only have an effect when the constraint owning this constraint reference has been explicitly added to a NXOpen::Positioning::Network .

The hint is forgotten after an update.


Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
setSet or unset the hint
void NXOpen::Positioning::ConstraintReference::SetFixHintForUpdate ( bool  set)

Set a hint to the solver to fix the movable object associated with this constraint reference.

The hint is unset when "set" is false.

The hint is forgotten after an update.

Ensures that the constraint that owns this reference will solve during the next call to NXOpen::Update::DoUpdate .


Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
setSet or unset the hint
void NXOpen::Positioning::ConstraintReference::SetGeometryDirectionReversed ( bool  geometryDirectionReversed)

Sets whether the direction is reversed with respect to the direction of the geometry.

This property is only used if the underlying geometry can have an associated direction.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
geometryDirectionReversedWhether the direction is reversed with respect to the geometry
void NXOpen::Positioning::ConstraintReference::SetHelpPoint ( const NXOpen::Point3d helpPoint)

Sets the help point of the constraint reference.


Created in NX4.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
helpPointCoordinates of point in part of constraint
void NXOpen::Positioning::ConstraintReference::SetPrototypePerpendicularVector ( const NXOpen::Vector3d perpendicularVector)

Set the value of the perpendicular vector.

The value must be a unit vector given in the coordinates of the part containing the referenced geometry.

The perpendicular vector must be set to (0,0,0) for most constraints apart from NXOpen::Positioning::Constraint::TypeAlignLock which must have a value. An error is raised if this is not the case.

Whenever the constraint is solved, the value of the perpendicular vector may be modified, to ensure that the vector is perpendicular to the referenced geometry.


Created in NX9.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
perpendicularVectorThe value of the perpendicular vector
void NXOpen::Positioning::ConstraintReference::SetUsePortRotateFlag ( bool  useRotate)

Sets the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system.

Only effective when the referenced geometry is a NXOpen::Routing::Port object.


Created in NX5.0.1.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
useRotateuse rotate
NXOpen::Positioning::ConstraintReference::GeometryType NXOpen::Positioning::ConstraintReference::SolverGeometryType ( )

Returns the geometry type of the constraint reference used during a solve.


Created in NX5.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

bool NXOpen::Positioning::ConstraintReference::UsePortRotateFlag ( )

Returns the flag forcing the use of the rotation vector of the referenced NXOpen::Routing::Port object instead of the alignment vector when solving the constraint system.

Only effective when the referenced geometry is a NXOpen::Routing::Port object.


Created in NX5.0.1.

License requirements : assemblies ("ASSEMBLIES MODULE")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.